House Robber

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed, the only constraint stopping you from robbing each of them is that adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

一看到题目就想到了动态规划(Dynamic Programming),在leetcode上还是第一次尝试,一直都是想想就觉得复杂,下不了手。不过这道题好在有点趣味性,所以还是硬着头皮写了出来。一开始在草稿纸上画着画着就大概画出了思路:由于要求数的不相邻性,所以对n个数分为两种情况,前n-2个数的max加上第n个数,以及前n-3个数的max加上第n-1个数,于是开始写,没想到写着写着写成了递归,私心想着递归应该也是可以实现的,运行了一下果然可以,但是坑爹的是leetcode里写好的函数声明只有数组名这一个参数,无法利用递归实现前n-1个数的数组递归,所以又纠结了好久。。。以斐波那契数列为例把动态规划又反复研究了一下,终于用DP实现了,而且实现的代码在Java提交里的运行速度很靠前,176ms吐舌头

public class Solution {
   public int rob(int[] num) {
      	int i = 0;
    	int n = num.length;
    	int newnum[] = new int[n + 1];
    	if (n == 0){
    		return 0;
    	}
    	if (n == 1){
    		return num[0];
    	}
    	if (n == 2){
    		return Math.max(num[0], num[1]);
    	}
    	newnum[0] = 0;
    	newnum[1] = num[0];
    	newnum[2] = Math.max(num[0], num[1]);
        if (n > 2){
        	for (i = 3; i <= n; i ++){
        		newnum[i] = Math.max(num[i - 1] + newnum[i - 2], num[i - 2] + newnum[i - 3]);
        		}
        }
        return newnum[i - 1];
    }
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值